//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrangeRed
#property indicator_color3  clrGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_maximum 1
#property indicator_minimum 0
#property strict

//
//
//
//
//

extern int                CCIFastPeriod = 14;             // Fast CCI period
extern int                CCISlowPeriod  =50;             // Slow CCI period
extern ENUM_APPLIED_PRICE CCIPrice       = PRICE_TYPICAL; // Price
extern double             OverSold       = -100;          // Oversold level
extern double             OverBought     =  100;          // Overbought level

double hisu[],hisd[],hisn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,hisu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hisd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,hisn); SetIndexStyle(2,DRAW_HISTOGRAM);
   IndicatorShortName("CCI ("+(string)CCIFastPeriod+","+(string)CCISlowPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double ccis = iCCI(NULL,0,CCISlowPeriod,CCIPrice,i);
      double ccif = iCCI(NULL,0,CCIFastPeriod,CCIPrice,i);
          hisu[i] = EMPTY_VALUE;
          hisd[i] = EMPTY_VALUE;
          hisn[i] = EMPTY_VALUE;
          if (ccif>OverBought && ccis>OverBought)           hisu[i] = 1;
          if (ccif<OverSold   && ccis<OverSold  )           hisd[i] = 1;
          if (hisu[i]==EMPTY_VALUE && hisd[i]==EMPTY_VALUE) hisn[i] = 1;
   }
   return(0);
}
